import sys
import os
import re


def els_with_offset(fileName):
    els = {}
    te_base_pattern = r"(?<=ID=TE_BASE_)\d+" #add underscores!!!
    with open(fileName) as f:
        for line in f:
            if "ID=TE_BASE_" in line:
                tmp = line.rstrip().split("\t")
                el_num = re.search(te_base_pattern, line).group(0)
                idd = "{}|TE-{}".format(tmp[0], el_num)
                els[idd] = int(tmp[3]) - 1
    return els


def add_offset(to_change, input_offset):
    elements = els_with_offset(input_offset)
    output = open("{}_gen_pos.gff3".format(os.path.splitext(to_change)[0]), 'w')
    processed = []
    current_id = ""
    last_id = ""
    with open(to_change) as f:
        for _ in range(5):
            output.write(f.readline())
        for line in f:
            if "Ambiguous_domain" in line:
                continue
            tmp = line.rstrip().split("\t")
            idd_1 = tmp[0].split("|")
            idd = "|".join([idd_1[0], idd_1[1].split("_")[0]])
            current_id = tmp[0]
            if current_id != last_id and last_id != "":
                split_last = last_id.split("|")
                processed.append(split_last[0] + "|" + split_last[1].split("_")[0])
            if idd in elements.keys() and idd not in processed:
                tmp[3] = str(int(tmp[3]) + elements[idd])
                tmp[4] = str(int(tmp[4]) + elements[idd])
                output.write(idd_1[0] + "\t" + "\t".join(tmp[1:]) + ";IDD=" + idd_1[1].split("_")[0] + "\n")
            last_id = current_id


add_offset(sys.argv[1], sys.argv[2])  # dante with relative pos, gff with offsets
